/*
					Plugin Created by Eden.Campo

                    GNU GENERAL PUBLIC LICENSE
                       Version 3, 29 June 2007

	Copyright (C) 2007 Free Software Foundation, Inc. <http://fsf.org/>
	Everyone is permitted to copy and distribute verbatim copies
	of this license document, but changing it is not allowed.

	To-Do List:
	
	Finish Bonuses(DONE - HALF)
	Finish Translations(TODO)
*/

#include <sourcemod>
#include <sdktools>
#include <morecolors>
#include <sdkhooks>
#include <dbi>
#include <store>

#pragma semicolon 1

#define PLUGIN_VERSION "1.0.1"

new Handle:hDatabase = INVALID_HANDLE;

new Handle:GangMainMenu = INVALID_HANDLE;
new Handle:GangLeaveMenu = INVALID_HANDLE;
new Handle:GangEditMenu = INVALID_HANDLE;
new Handle:GangAcceptMessage = INVALID_HANDLE;
new Handle:GangPremoteDemoteMenu = INVALID_HANDLE;
new Handle:GangBonusesMenu = INVALID_HANDLE;
new Handle:GangBonusesExplainMenu = INVALID_HANDLE;
new Handle:GangBankMenu = INVALID_HANDLE;
new Handle:GangPrivacyMenu = INVALID_HANDLE;
new Handle:GangMasterKeyMenu = INVALID_HANDLE;

new Handle:GRemovePlayer = INVALID_HANDLE;
new Handle:GAddPlayer = INVALID_HANDLE;
new Handle:GangListMenuDelete = INVALID_HANDLE;
new Handle:GangListMenuPass = INVALID_HANDLE;
new Handle:GangListerMenu = INVALID_HANDLE;
new Handle:GangMasterRemoveMenu = INVALID_HANDLE;

new Handle:g_hGangCreateCredits = INVALID_HANDLE;
new Handle:g_hGangUpgradeBonusCredits = INVALID_HANDLE;
new Handle:g_hGangChangeNameCredits = INVALID_HANDLE;
new Handle:g_hGangExpendSlotsCredits = INVALID_HANDLE;
new Handle:g_hGangDisbandUsePass = INVALID_HANDLE;
new Handle:g_hGangUseRanks = INVALID_HANDLE;
new Handle:g_hGangMaxMembers = INVALID_HANDLE;
new Handle:g_hGangBank = INVALID_HANDLE;
new Handle:g_hGangMasterKeyUse = INVALID_HANDLE;
new Handle:g_hGangMasterKey = INVALID_HANDLE;

new bool:inExpendSlotsProcess[MAXPLAYERS] = false;
new bool:inPremoteDemoteProcess[MAXPLAYERS] = false;
new bool:inCreateDisbandPassProcess[MAXPLAYERS] = false;
new bool:inEditDisbandPassProcess[MAXPLAYERS] = false;
new bool:inGangDisbandProcess[MAXPLAYERS] = false;
new bool:inGangChangeNameProcess[MAXPLAYERS] = false;
new bool:inGangMasterKeyProcess[MAXPLAYERS] = false;
new bool:inGangBankDepositProcess[MAXPLAYERS] = false;
new bool:inGangWithdrawProcess[MAXPLAYERS] = false;

new String:TempArgument[200];
new String:BonusToUpgrade[200];
new String:GangToEdit[200];
new String:GangListerGangToJoin[200];
new String:PendingGang[64];
new String:NameToChange[400];
new MemberToRank;
new CreditsToAdd;
new CreditsToRemove;
new GangInviter;

public Plugin:myinfo =
{
	name = "Gangs - Create 'Gangs' and be the one who rules the server!",
	author = "Eden.Campo",
	description = "Create and Lead the best Gangs on the server!",
	version = PLUGIN_VERSION,
	url = "https://forums.alliedmods.net/member.php?u=226366"
}

public OnPluginStart()
{
	LoadTranslations("gangs.phrases");

	StartSQL();
	
	g_hGangCreateCredits = CreateConVar("gangs_create_credits", "1500", "Decides how many credits you need to create a new Gang");
	g_hGangUpgradeBonusCredits = CreateConVar("gangs_bonus_upgrade_credits", "1500", "Decides how much credits will it cost to upgrade a bonus"); 
	g_hGangChangeNameCredits =  CreateConVar("gangs_changename_credits", "1000", "Decides how much credits will it cost to change a gang name"); 
	g_hGangExpendSlotsCredits = CreateConVar("gangs_expend_credits_per_slot", "750", "Decides how much credits will it cost to expend a gang"); 
	g_hGangDisbandUsePass = CreateConVar("gangs_use_disband_pass", "1", "Decides if anyone can disband a Gang with a password, or just the Leader");
	g_hGangUseRanks = CreateConVar("gangs_use_ranks", "1", "Decides if Gangs will be using Ranks for permissions or everyone can do anything");
	g_hGangMaxMembers = CreateConVar("gangs_max_members", "10", "Maximum members that can be at a Gang (AFTER EXPENTION)");
	g_hGangBank = CreateConVar("gangs_bank", "1", "Use Gang Banks? 1 = Yes, 0 = No");
	g_hGangMasterKeyUse = CreateConVar("gangs_masterkey_use", "1", "If enabled everyone with Master Key will be able to control every Gang!");
	g_hGangMasterKey = CreateConVar("gangs_masterkey", "", "Define your Master Key here");

	AutoExecConfig(true, "Gangs");
	
	GangMainMenu = CreateMenu(GangMainMenuHandler);
	GangLeaveMenu = CreateMenu(GangLeaveMenuHandler);
	GangEditMenu  = CreateMenu(GangEditMenuHandler);
	GangAcceptMessage = CreateMenu(GangAcceptMessageHandler);
	GangPremoteDemoteMenu = CreateMenu(GangPremoteDemoteMenuHandler);
	GangBonusesMenu = CreateMenu(GangBonusesMenuHandler);
	GangBonusesExplainMenu = CreateMenu(GangBonusesExplainMenuHandler);
	GangBankMenu = CreateMenu(GangBankMenuHandler);
	GangPrivacyMenu = CreateMenu(GangPrivacyMenuHandler);
	GangMasterKeyMenu = CreateMenu(GangMasterKeyMenuHandler);
	
	SetMenuExitButton(GangMainMenu, true);
	SetMenuExitBackButton(GangMainMenu, false);
	
	new String:GangLeaveTitle[400];
	Format(GangLeaveTitle, sizeof(GangLeaveTitle), "%T", "Gang Leave Title", LANG_SERVER);
	SetMenuTitle(GangLeaveMenu, GangLeaveTitle);
	AddMenuItem(GangLeaveMenu, "1", "Leave Gang");
	AddMenuItem(GangLeaveMenu, "2", "Stay in Gang");
	SetMenuExitButton(GangLeaveMenu, false);
	SetMenuExitBackButton(GangLeaveMenu, false);
	
	new String:GangEditTitle[400];
	Format(GangEditTitle, sizeof(GangEditTitle), "%T", "Gang Edit Title", LANG_SERVER);
	SetMenuTitle(GangEditMenu, GangEditTitle);
	AddMenuItem(GangEditMenu, "1", "Change Gang Name");
	AddMenuItem(GangEditMenu, "2", "Change Gang Privacy");
	AddMenuItem(GangEditMenu, "3", "Disband Gang");
	SetMenuExitButton(GangEditMenu, true);
	SetMenuExitBackButton(GangEditMenu, false);
	
	AddMenuItem(GangAcceptMessage, "1", "Join Gang");
	AddMenuItem(GangAcceptMessage, "2", "Decline Request");
	SetMenuExitButton(GangAcceptMessage, false);
	SetMenuExitBackButton(GangAcceptMessage, false);
	
	new String:GangBonusesTitle[400];
	Format(GangBonusesTitle, sizeof(GangBonusesTitle), "%T", "Gang Bonuses Title", LANG_SERVER);
	SetMenuTitle(GangBonusesMenu, GangBonusesTitle);
	AddMenuItem(GangBonusesMenu, "1", "Armor Bonus");
	AddMenuItem(GangBonusesMenu, "2", "Gun Bonus", ITEMDRAW_RAWLINE);
	AddMenuItem(GangBonusesMenu, "3", "Health Bonus");
	AddMenuItem(GangBonusesMenu, "4", "Grenade Bonus");
	AddMenuItem(GangBonusesMenu, "5", "CT Drop Bonus", ITEMDRAW_RAWLINE);
	SetMenuExitButton(GangBonusesMenu, true);
	SetMenuExitBackButton(GangBonusesMenu, false);
	
	SetMenuExitButton(GangBankMenu, true);
	SetMenuExitBackButton(GangBankMenu, false);
	
	new String:GangPrivacyTitle[400];
	Format(GangPrivacyTitle, sizeof(GangPrivacyTitle), "%T", "Gang Privacy Title", LANG_SERVER);
	SetMenuTitle(GangPrivacyMenu, GangPrivacyTitle);
	AddMenuItem(GangPrivacyMenu, "1", "Set Public Gang");
	AddMenuItem(GangPrivacyMenu, "2", "Set Private Gang");
	SetMenuExitButton(GangPrivacyMenu, true);
	SetMenuExitBackButton(GangPrivacyMenu, false);
	
	new String:GangAdminTitle[400];
	Format(GangAdminTitle, sizeof(GangAdminTitle), "%T", "Gang Admin Title", LANG_SERVER);
	SetMenuTitle(GangMasterKeyMenu, GangAdminTitle);
	AddMenuItem(GangMasterKeyMenu, "1", "Change Gang Privacy");
	AddMenuItem(GangMasterKeyMenu, "2", "Delete Gangs");
	AddMenuItem(GangMasterKeyMenu, "3", "Expel Gang Member");
	AddMenuItem(GangMasterKeyMenu, "4", "Change Gang Password");
	AddMenuItem(GangMasterKeyMenu, "5", "Unlock Gang to Master Gang", ITEMDRAW_RAWLINE);
	SetMenuExitButton(GangMasterKeyMenu, true);
	SetMenuExitBackButton(GangMasterKeyMenu, false);
	
	
	RegConsoleCmd("sm_creategang", Command_CreateGang);
	RegConsoleCmd("sm_disbandgang", Command_DisbandGang);
	RegConsoleCmd("sm_gang", Command_Gang);
	RegConsoleCmd("sm_gangs", Command_Gangs);
	RegConsoleCmd("sm_cancel", Command_Cancel);
	
	RegAdminCmd("sm_gangmaster", Command_GangMaster, ADMFLAG_GENERIC);
	
	AddCommandListener(Command_Say, "say");
	
	HookEvent("player_spawn", onPlayerSpawn);
}

public Action:onPlayerSpawn(Handle:event, const String:name[], bool:dontBroadcast)
{
	new client_id = GetEventInt(event, "userid");
	new client = GetClientOfUserId(client_id);
	
	new String:auth[32];
	new String:query[2000];
	new String:gang[62];
	GetClientAuthString(client, auth, sizeof(auth));
	Format(query, sizeof(query), "SELECT Gang FROM Gangs_Users WHERE SteamID = '%s'", auth);
	
	new Handle:hQuery = SQL_Query(hDatabase, query);
	if (hQuery == INVALID_HANDLE)
	{
		return Plugin_Handled;
	}
	else
	{		
		while (SQL_FetchRow(hQuery))
		{
			SQL_FetchString(hQuery, 0, gang, sizeof(gang));
		}
	}
	
	CheckArmorBonus(gang, client);
	CheckGunBonus(gang, client);
	CheckHealthBonus(gang, client);
	CheckGrenadeBonus(gang, client);
	
	return Plugin_Continue;
}


public Action:Command_Say(client, const String:command[], args)
{	
	if(client == 0)
	{
		return Plugin_Continue;
	}

	new String:Text[264];
	GetCmdArg(1, Text, sizeof(Text));
	
	new String:auth[32];
	new String:query[2000];
	new String:query1[2000];
	new String:query2[2000];
	new String:gang[62];
	new String:password[264];
	GetClientAuthString(client, auth, sizeof(auth));
	Format(query, sizeof(query), "SELECT Gang FROM Gangs_Users WHERE SteamID = '%s'", auth);
	
	new MaxMembers;
	
	new Handle:hQuery = SQL_Query(hDatabase, query);
	if (hQuery == INVALID_HANDLE)
	{
		return Plugin_Handled;
	}
	else
	{		
		while (SQL_FetchRow(hQuery))
		{
			SQL_FetchString(hQuery, 0, gang, sizeof(gang));
		}
	}
	
	Format(query1, sizeof(query1), "SELECT GangPass FROM Gangs_Ganglist WHERE GangName = '%s'", gang);
	
	new Handle:hQuery1 = SQL_Query(hDatabase, query1);
	if (hQuery1 == INVALID_HANDLE)
	{
		return Plugin_Handled;
	}
	else
	{		
		while (SQL_FetchRow(hQuery1))
		{
			SQL_FetchString(hQuery1, 0, password, sizeof(password));
		}
	}
	
	Format(query2, sizeof(query2), "SELECT MaxMembers FROM Gangs_Ganglist WHERE GangName = '%s'", gang);
	
	new Handle:hQuery2 = SQL_Query(hDatabase, query2);
	if (hQuery2 == INVALID_HANDLE)
	{
		SetFailState("error while query(2)");
	}
	else
	{		
		while (SQL_FetchRow(hQuery2))
		{
			MaxMembers = SQL_FetchInt(hQuery2, 0);
		}
	}
	
	
	if(inExpendSlotsProcess[client] == true)
	{	
		new GangMaxMembers = GetConVarInt(g_hGangMaxMembers);
		
		if(GangMaxMembers == MaxMembers)
		{
			CPrintToChat(client, "%T", "Max Slots Reached", LANG_SERVER);
			return Plugin_Handled;
		}
		
		if(StrEqual(Text, "1"))
		{
			Store_GetCredits(Store_GetClientAccountID(client), ExpendByOneCallback, client);
			return Plugin_Handled;
		}
		else if(StrEqual(Text, "2"))
		{
			Store_GetCredits(Store_GetClientAccountID(client), ExpendByTwoCallback, client);
			return Plugin_Handled;
		}
		else if(StrEqual(Text, "3"))
		{
			Store_GetCredits(Store_GetClientAccountID(client), ExpendByThreeCallback, client);
			return Plugin_Handled;
		}
		else if(StrEqual(Text, "4"))
		{
			Store_GetCredits(Store_GetClientAccountID(client), ExpendByFourCallback, client);
			return Plugin_Handled;
		}
		else if(StrEqual(Text, "5"))
		{
			Store_GetCredits(Store_GetClientAccountID(client), ExpendByFiveCallback, client);
			return Plugin_Handled;
		}
		else if(StrEqual(Text, "!cancel"))
		{
			return Plugin_Handled;
		}
		else
		{
			CPrintToChat(client, "%T", "Must be a Value", LANG_SERVER);
			inExpendSlotsProcess[client] = false;
		}
	}
		
	if(inPremoteDemoteProcess[client] == true)
	{
		if(StrEqual(Text, "newbie", false))
		{
			CPrintToChat(client, "%T", "Successfully Set Newbie", LANG_SERVER, MemberToRank);
			SetGangMemberRank(MemberToRank, "Newbie");
			inPremoteDemoteProcess[client] = false;
			return Plugin_Handled;
		}
		else if(StrEqual(Text, "member", false))
		{
			CPrintToChat(client, "%T", "Successfully Set Member", LANG_SERVER, MemberToRank);
			SetGangMemberRank(MemberToRank, "Member");
			inPremoteDemoteProcess[client] = false;
			return Plugin_Handled;
		}
		else if(StrEqual(Text, "officer", false))
		{
			CPrintToChat(client, "%T", "Successfully Set Officer", LANG_SERVER, MemberToRank);
			SetGangMemberRank(MemberToRank, "Officer");
			inPremoteDemoteProcess[client] = false;
			return Plugin_Handled;
		}
		else if(StrEqual(Text, "Veteran", false))
		{
			CPrintToChat(client, "%T", "Successfully Set Veteran", LANG_SERVER, MemberToRank);
			SetGangMemberRank(MemberToRank, "Veteran");
			inPremoteDemoteProcess[client] = false;
			return Plugin_Handled;
		}
		else if(StrEqual(Text, "Leader", false))
		{
			CPrintToChat(client, "%T", "Successfully Set Leader", LANG_SERVER, MemberToRank);
			SetGangMemberRank(MemberToRank, "Leader");
			inPremoteDemoteProcess[client] = false;
			return Plugin_Handled;
		}
		else if(StrEqual(Text, "!cancel"))
		{
			return Plugin_Handled;
		}
		else
		{
			CPrintToChat(client, "%T", "Successfully Set Custom", LANG_SERVER, MemberToRank, Text);
			SetGangMemberRank(MemberToRank, Text);
			inPremoteDemoteProcess[client] = false;
			return Plugin_Handled;
		}
	}
	
	if(inCreateDisbandPassProcess[client] == true)
	{
		CreateGangPassword(Text, gang);
		inCreateDisbandPassProcess[client] = false;
		CPrintToChat(client, "%T", "Success Disband Own", LANG_SERVER, Text);
		return Plugin_Handled;
	}
	
	if(inEditDisbandPassProcess[client] == true)
	{
		CreateGangPassword(Text, GangToEdit);
		inEditDisbandPassProcess[client] = false;
		CPrintToChat(client, "%T", "Success Disband Others", LANG_SERVER, GangToEdit, Text);
		return Plugin_Handled;
	}
	
	if(inGangDisbandProcess[client] == true)
	{
		if(StrEqual(password, Text))
		{
			CPrintToChat(client, "%T", "Correct Password Disband", LANG_SERVER);
			DisbandGang(gang);
			inGangDisbandProcess[client] = false;
			return Plugin_Handled;
		}
		else
		{
			CPrintToChat(client, "%T", "Incorrect Password Disband", LANG_SERVER);
			inGangDisbandProcess[client] = false;
			return Plugin_Handled;
		}
	}
	
	if(inGangChangeNameProcess[client] == true)
	{
		Store_GetCredits(Store_GetClientAccountID(client), GangChangeNameCreditCallback, client);
		Format(NameToChange, sizeof(NameToChange), "%s", Text);
		inGangChangeNameProcess[client] = false;
		return Plugin_Handled;
	}
	
	if(inGangMasterKeyProcess[client] == true)
	{
		new String:RightMasterKey[400];
		GetConVarString(g_hGangMasterKey, RightMasterKey, sizeof(RightMasterKey));
		
		if(StrEqual(Text, RightMasterKey))
		{
			CPrintToChat(client, "%T", "Correct", LANG_SERVER);
			DisplayMenu(GangMasterKeyMenu, client, MENU_TIME_FOREVER);
			inGangMasterKeyProcess[client] = false;
			return Plugin_Handled;
		}
		else
		{
			CPrintToChat(client, "%T", "Incorrect", LANG_SERVER);
			inGangMasterKeyProcess[client] = false;
			return Plugin_Handled;
		}
	}
	
	if(inGangBankDepositProcess[client] == true)
	{
		CreditsToAdd = StringToInt(Text);
		Store_GetCredits(Store_GetClientAccountID(client), BankDepositCallback, client);
		return Plugin_Handled;
	}
	
	if(inGangWithdrawProcess[client] == true)
	{
		CreditsToRemove = StringToInt(Text);
		Store_GetCredits(Store_GetClientAccountID(client), BankWithdrawCallback, client);
		return Plugin_Handled;
	}
	
	return Plugin_Continue;
}

public Action:Command_CreateGang(client, args)
{
	if(args < 1)
	{
		new CreditsToCreate = GetConVarInt(g_hGangCreateCredits);
		CPrintToChat(client, "{green}[Gangs]{default} Usage: !creategang <name>");
		CPrintToChat(client, "%T", "Create Gang Warning", CreditsToCreate);
		return Plugin_Handled;
	}

	new String:arg[62];
	new String:gang[62];
	decl String:query[2000];
	decl String:auth[32];
	GetClientAuthString(client, auth, sizeof(auth));
	GetCmdArg(1, arg, sizeof(arg));
	
	if(StrEqual(arg, "none"))
	{
		CPrintToChat(client, "%T", "Cant use name", LANG_SERVER);
		return Plugin_Handled;
	}
	
	Format(query, sizeof(query), "SELECT Gang FROM Gangs_Users WHERE SteamID = '%s'", auth);
	
	new Handle:hQuery = SQL_Query(hDatabase, query);
	if (hQuery == INVALID_HANDLE)
	{
		SetFailState("error while query(gang retrive)");
	}
	else
	{		
		while (SQL_FetchRow(hQuery))
		{
			SQL_FetchString(hQuery, 0, gang, sizeof(gang));
		}
	}
	
	if(!StrEqual(gang, "none"))
	{
		CPrintToChat(client, "%T", "Cant create more then", LANG_SERVER);
		return Plugin_Handled;
	}
	
	new String:query1[2000];
	Format(query1, sizeof(query1), "SELECT GangName FROM Gangs_Ganglist WHERE GangName = '%s'", arg); 
	new Handle:hQuery1 = SQL_Query(hDatabase, query1);
	if (hQuery1 == INVALID_HANDLE)
	{
		return Plugin_Handled;
	} 
	else 
	{
		if (!SQL_GetRowCount(hQuery1)) 
		{
			Store_GetCredits(Store_GetClientAccountID(client), CreateGangCreditCallback, client);
			Format(TempArgument, sizeof(TempArgument), "%s", arg);
		}
		else
		{
			CPrintToChat(client, "%T", "Name already taken", LANG_SERVER);
		}
	}
	return Plugin_Handled;
}

public Action:Command_DisbandGang(client, args)
{
	new DisbandUsePass = GetConVarInt(g_hGangDisbandUsePass);
	
	if(DisbandUsePass == 1)
	{
		CPrintToChat(client, "%T", "Cant disband because pass", LANG_SERVER);
		return Plugin_Handled;
	}
	
	new String:auth[32];
	new String:query[100];
	
	new String:rank[62];
	GetClientAuthString(client, auth, sizeof(auth));
	Format(query, sizeof(query), "SELECT Rank FROM Gangs_Users WHERE SteamID = '%s'", auth);
	
	new Handle:hQuery = SQL_Query(hDatabase, query);
	if (hQuery == INVALID_HANDLE)
	{
		SetFailState("error while query(3)");
	}
	else
	{		
		while (SQL_FetchRow(hQuery))
		{
			SQL_FetchString(hQuery, 0, rank, sizeof(rank));
		}
	}
	
	
	new String:gang[62];
	decl String:query1[2000];
	
	Format(query1, sizeof(query1), "SELECT Gang FROM Gangs_Users WHERE SteamID = '%s'", auth);
	
	new Handle:hQuery1 = SQL_Query(hDatabase, query1);
	if (hQuery1 == INVALID_HANDLE)
	{
		SetFailState("error while query1(gang retrive)");
	}
	else
	{		
		while (SQL_FetchRow(hQuery1))
		{
			SQL_FetchString(hQuery1, 0, gang, sizeof(gang));
		}
	}
		
	if(StrEqual(rank, "Leader"))
	{
		DisbandGang(gang);
		CPrintToChat(client, "%T", "Successfully Disband Gang(by command)", LANG_SERVER);
	}
	else
	{
		CPrintToChat(client, "%T", "Not Leader cant disband", LANG_SERVER);
	}

	return Plugin_Handled;
}

public Action:Command_Gang(client, args)
{
	new String:RemadeTitleGang[200];
	new String:RankMenuItem[200];
	new String:MembersOMembers[200];
	
	new String:auth[32];
	new String:query[2000];
	new String:query1[2000];
	
	new String:gang[62];
	new String:rank[62];
	new Members;
	new MaxMembers;
	GetClientAuthString(client, auth, sizeof(auth));
	Format(query, sizeof(query), "SELECT * FROM Gangs_Users WHERE SteamID = '%s'", auth);
	
	new Handle:hQuery = SQL_Query(hDatabase, query);
	if (hQuery == INVALID_HANDLE)
	{
		SetFailState("error while query(0)");
	}
	else
	{		
		while (SQL_FetchRow(hQuery))
		{
			SQL_FetchString(hQuery, 2, gang, sizeof(gang));
			SQL_FetchString(hQuery, 3, rank, sizeof(rank));
		}
	}
	
	Format(query1, sizeof(query1), "SELECT * FROM Gangs_Ganglist WHERE GangName = '%s'", gang);
	
	new Handle:hQuery1 = SQL_Query(hDatabase, query1);
	if (hQuery1 == INVALID_HANDLE)
	{
		SetFailState("error while query(1)");
	}
	else
	{		
		while (SQL_FetchRow(hQuery1))
		{
			Members = SQL_FetchInt(hQuery1, 3);
			MaxMembers = SQL_FetchInt(hQuery1, 4);
		}
	}
	
	if(StrEqual(gang, "none"))
	{
		CPrintToChat(client, "%T", "You have no Gang", LANG_SERVER);
		return Plugin_Handled;
	}
	
	Format(RemadeTitleGang, sizeof(RemadeTitleGang), "Welcome to Gang - %s", gang);
	Format(RankMenuItem, sizeof(RankMenuItem), "Your Gang Rank is: %s", rank);
	Format(MembersOMembers, sizeof(MembersOMembers), "Current Gang Slots: %i/%i", Members, MaxMembers);
	
	GangMainMenu = CreateMenu(GangMainMenuHandler);
	
	SetMenuTitle(GangMainMenu, RemadeTitleGang);
	AddMenuItem(GangMainMenu, "rank", RankMenuItem, ITEMDRAW_DISABLED);
	AddMenuItem(GangMainMenu, "mem/mem", MembersOMembers, ITEMDRAW_DISABLED);

	
	new GangUseRanks = GetConVarInt(g_hGangUseRanks);
	
	if(GangUseRanks == 0)
	{
	AddMenuItem(GangMainMenu, "1", "Add Gang Member");
	AddMenuItem(GangMainMenu, "2", "Expel Gang Member");
	AddMenuItem(GangMainMenu, "3", "Expend Gang Slots");
	AddMenuItem(GangMainMenu, "4", "Demote/Premote Member");
	AddMenuItem(GangMainMenu, "5", "Gang Bonuses");
	AddMenuItem(GangMainMenu, "6", "Edit Gang");
	AddMenuItem(GangMainMenu, "7", "Current Gang Stats");
	AddMenuItem(GangMainMenu, "8", "Gang Bank");
	AddMenuItem(GangMainMenu, "9", "Leave Gang");
	}
	else
	{
		if(StrEqual(rank, "Leader"))
		{
		AddMenuItem(GangMainMenu, "1", "Add Gang Member");
		AddMenuItem(GangMainMenu, "2", "Expel Gang Member");
		AddMenuItem(GangMainMenu, "3", "Expend Gang Slots");
		AddMenuItem(GangMainMenu, "4", "Demote/Premote Member");
		AddMenuItem(GangMainMenu, "5", "Gang Bonuses");
		AddMenuItem(GangMainMenu, "6", "Edit Gang");
		AddMenuItem(GangMainMenu, "7", "Current Gang Stats");
		AddMenuItem(GangMainMenu, "8", "Gang Bank");
		AddMenuItem(GangMainMenu, "9", "Leave Gang", ITEMDRAW_RAWLINE);
		}
		else if(StrEqual(rank, "Veteran"))
		{
		AddMenuItem(GangMainMenu, "1", "Add Gang Member");
		AddMenuItem(GangMainMenu, "2", "Expel Gang Member");
		AddMenuItem(GangMainMenu, "3", "Expend Gang Slots");
		AddMenuItem(GangMainMenu, "4", "Demote/Premote Member", ITEMDRAW_RAWLINE);
		AddMenuItem(GangMainMenu, "5", "Gang Bonuses");
		AddMenuItem(GangMainMenu, "6", "Edit Gang", ITEMDRAW_RAWLINE);
		AddMenuItem(GangMainMenu, "7", "Current Gang Stats");
		AddMenuItem(GangMainMenu, "8", "Gang Bank");
		AddMenuItem(GangMainMenu, "9", "Leave Gang");
		}
		else if(StrEqual(rank, "Officer"))
		{
		AddMenuItem(GangMainMenu, "1", "Add Gang Member");
		AddMenuItem(GangMainMenu, "2", "Expel Gang Member", ITEMDRAW_RAWLINE);
		AddMenuItem(GangMainMenu, "3", "Expend Gang Slots");
		AddMenuItem(GangMainMenu, "4", "Demote/Premote Member", ITEMDRAW_RAWLINE);
		AddMenuItem(GangMainMenu, "5", "Gang Bonuses");
		AddMenuItem(GangMainMenu, "6", "Edit Gang", ITEMDRAW_RAWLINE);
		AddMenuItem(GangMainMenu, "7", "Current Gang Stats");
		AddMenuItem(GangMainMenu, "8", "Gang Bank");
		AddMenuItem(GangMainMenu, "9", "Leave Gang");
		}
		else if(StrEqual(rank, "Member") || StrEqual(rank, "Newbie"))
		{
		AddMenuItem(GangMainMenu, "1", "Add Gang Member", ITEMDRAW_RAWLINE);
		AddMenuItem(GangMainMenu, "2", "Expel Gang Member", ITEMDRAW_RAWLINE);
		AddMenuItem(GangMainMenu, "3", "Expend Gang Slots", ITEMDRAW_RAWLINE);
		AddMenuItem(GangMainMenu, "4", "Demote/Premote Member", ITEMDRAW_RAWLINE);
		AddMenuItem(GangMainMenu, "5", "Gang Bonuses");
		AddMenuItem(GangMainMenu, "6", "Edit Gang", ITEMDRAW_RAWLINE);
		AddMenuItem(GangMainMenu, "7", "Current Gang Stats");
		AddMenuItem(GangMainMenu, "8", "Gang Bank");
		AddMenuItem(GangMainMenu, "9", "Leave Gang");
		}
		else
		{
		AddMenuItem(GangMainMenu, "1", "Add Gang Member", ITEMDRAW_RAWLINE);
		AddMenuItem(GangMainMenu, "2", "Expel Gang Member", ITEMDRAW_RAWLINE);
		AddMenuItem(GangMainMenu, "3", "Expend Gang Slots", ITEMDRAW_RAWLINE);
		AddMenuItem(GangMainMenu, "4", "Demote/Premote Member", ITEMDRAW_RAWLINE);
		AddMenuItem(GangMainMenu, "5", "Gang Bonuses");
		AddMenuItem(GangMainMenu, "6", "Edit Gang", ITEMDRAW_RAWLINE);
		AddMenuItem(GangMainMenu, "7", "Current Gang Stats");
		AddMenuItem(GangMainMenu, "8", "Gang Bank");
		AddMenuItem(GangMainMenu, "9", "Leave Gang");
		}
	}
	
	DisplayMenu(GangMainMenu, client, MENU_TIME_FOREVER);
	return Plugin_Handled;
}

public Action:Command_Gangs(client, args)
{
	DisplayGangListerMenu(client);
	CPrintToChat(client, "%T", "Showing current Gangs", LANG_SERVER);
}

public Action:Command_GangMaster(client, args)
{
	new MasterKeyEnabled = GetConVarInt(g_hGangMasterKeyUse);
	
	if(MasterKeyEnabled == 0)
	{
		CPrintToChat(client, "%T", "Master Key Disabled", LANG_SERVER);
		return Plugin_Handled;
	}
	else
	{
		CPrintToChat(client, "%T", "Please enter Master Key", LANG_SERVER);
		inGangMasterKeyProcess[client] = true;
	}
	
	return Plugin_Handled;
}

public Action:Command_Cancel(client, args)
{
	inExpendSlotsProcess[client] = false;
	inPremoteDemoteProcess[client] = false;
	inCreateDisbandPassProcess[client] = false;
	inGangDisbandProcess[client] = false;
	inGangChangeNameProcess[client] = false;
	inGangMasterKeyProcess[client] = false;
	inGangBankDepositProcess[client] = false;
	inGangWithdrawProcess[client] = false;
	
	CPrintToChat(client, "%T", "Canceled running process", LANG_SERVER);
	return Plugin_Handled;
}

public GangChangeNameCreditCallback(credits, any:client)
{
		new ChangeNameCost = GetConVarInt(g_hGangChangeNameCredits);
		
		if(credits >= ChangeNameCost)
		{
			new String:gang[62];
			decl String:query[2000];
			decl String:auth[32];
			GetClientAuthString(client, auth, sizeof(auth));
	
			Format(query, sizeof(query), "SELECT Gang FROM Gangs_Users WHERE SteamID = '%s'", auth);
	
			new Handle:hQuery = SQL_Query(hDatabase, query);
			if (hQuery == INVALID_HANDLE)
			{
				SetFailState("error while query(gang retrive)");
			}
			else
			{		
				while (SQL_FetchRow(hQuery))
				{
					SQL_FetchString(hQuery, 0, gang, sizeof(gang));
				}
			}
		
			UpdateGangName(gang, NameToChange);
			Store_GiveCredits(Store_GetClientAccountID(client), -ChangeNameCost);
			CPrintToChat(client, "%T", "Success update GangName", LANG_SERVER, NameToChange);
		}
		else
		{
			CPrintToChat(client, "%T", "Not enough credits GangName", LANG_SERVER);
		}
}

public BankDepositCallback(credits, any:client)
{
	if(credits < CreditsToAdd)
	{
		CPrintToChat(client, "%T", "Deposit Failed", LANG_SERVER);
	}
	else
	{
		new String:gang[62];
		new String:query[2000];
		decl String:auth[32];
		GetClientAuthString(client, auth, sizeof(auth));
		Format(query, sizeof(query), "SELECT Gang FROM Gangs_Users WHERE SteamID = '%s'", auth);
	
		new Handle:hQuery = SQL_Query(hDatabase, query);
		if (hQuery == INVALID_HANDLE)
		{
			return;
		}
		else
		{		
			while (SQL_FetchRow(hQuery))
			{
				SQL_FetchString(hQuery, 0, gang, sizeof(gang));
			}
		}
	
		AddBankCredits(gang, CreditsToAdd);
		Store_GiveCredits(Store_GetClientAccountID(client), -CreditsToAdd);
		CPrintToChat(client, "%T", "Deposit Success", LANG_SERVER, CreditsToAdd);
		inGangBankDepositProcess[client] = false;
	}
}

public BankWithdrawCallback(credits, any:client)
{
	new String:gang[62];
	new String:query[2000];
	decl String:auth[32];
	GetClientAuthString(client, auth, sizeof(auth));
	Format(query, sizeof(query), "SELECT Gang FROM Gangs_Users WHERE SteamID = '%s'", auth);
	
	new Handle:hQuery = SQL_Query(hDatabase, query);
	if (hQuery == INVALID_HANDLE)
	{
		return;
	}
	else
	{		
		while (SQL_FetchRow(hQuery))
		{
			SQL_FetchString(hQuery, 0, gang, sizeof(gang));
		}
	}


	decl String:query1[2000];
	new GangCredits;
	Format(query1, sizeof(query1), "SELECT GangBank FROM Gangs_Ganglist WHERE GangName = '%s'", gang);
	
	new Handle:hQuery1 = SQL_Query(hDatabase, query1);
	if (hQuery1 == INVALID_HANDLE)
	{
		SetFailState("error while query1");
	}
	else
	{		
		while (SQL_FetchRow(hQuery1))
		{
			GangCredits = SQL_FetchInt(hQuery1, 0);
		}
	}
	
	if(GangCredits < CreditsToRemove)
	{
		CPrintToChat(client, "%T", "Withdraw Failed", LANG_SERVER);
	}
	else
	{
		RemoveBankCredits(gang, CreditsToRemove);
		Store_GiveCredits(Store_GetClientAccountID(client), CreditsToRemove);
		CPrintToChat(client, "%T", "Withdraw Success", LANG_SERVER, CreditsToRemove);
		inGangWithdrawProcess[client] = false;
	}
}

public ExpendByOneCallback(credits, any:client)
{	
	if(credits >= 750)
	{
		new String:auth[32];
		new String:query[2000];
		new String:gang[62];
		GetClientAuthString(client, auth, sizeof(auth));
		Format(query, sizeof(query), "SELECT Gang FROM Gangs_Users WHERE SteamID = '%s'", auth);
	
		new Handle:hQuery = SQL_Query(hDatabase, query);
		if (hQuery == INVALID_HANDLE)
		{
			return;
		}
		else
		{		
			while (SQL_FetchRow(hQuery))
			{
				SQL_FetchString(hQuery, 0, gang, sizeof(gang));
			}
		}
		CPrintToChat(client, "%T", "Expend by 1", LANG_SERVER);
		ExpendGangSlotsByNum(gang, 1);
		inExpendSlotsProcess[client] = false;
		
		Store_GiveCredits(Store_GetClientAccountID(client), -750);
	}
	else
	{
		CPrintToChat(client, "%T", "Expend not enough credits", LANG_SERVER);
	}
}

public ExpendByTwoCallback(credits, any:client)
{	
	if(credits >= 1500)
	{
		new String:auth[32];
		new String:query[2000];
		new String:gang[62];
		GetClientAuthString(client, auth, sizeof(auth));
		Format(query, sizeof(query), "SELECT Gang FROM Gangs_Users WHERE SteamID = '%s'", auth);
	
		new Handle:hQuery = SQL_Query(hDatabase, query);
		if (hQuery == INVALID_HANDLE)
		{
			return;
		}
		else
		{		
			while (SQL_FetchRow(hQuery))
			{
				SQL_FetchString(hQuery, 0, gang, sizeof(gang));
			}
		}
		CPrintToChat(client, "%T", "Expend by 2", LANG_SERVER);
		ExpendGangSlotsByNum(gang, 2);
		inExpendSlotsProcess[client] = false;
		Store_GiveCredits(Store_GetClientAccountID(client), -1500);
	}
	else
	{
		CPrintToChat(client, "%T", "Expend not enough credits", LANG_SERVER);
	}
}

public ExpendByThreeCallback(credits, any:client)
{	
	if(credits >= 2250)
	{
		new String:auth[32];
		new String:query[2000];
		new String:gang[62];
		GetClientAuthString(client, auth, sizeof(auth));
		Format(query, sizeof(query), "SELECT Gang FROM Gangs_Users WHERE SteamID = '%s'", auth);
	
		new Handle:hQuery = SQL_Query(hDatabase, query);
		if (hQuery == INVALID_HANDLE)
		{
			return;
		}
		else
		{		
			while (SQL_FetchRow(hQuery))
			{
				SQL_FetchString(hQuery, 0, gang, sizeof(gang));
			}
		}
		CPrintToChat(client, "%T", "Expend by 3", LANG_SERVER);
		ExpendGangSlotsByNum(gang, 3);
		inExpendSlotsProcess[client] = false;
		Store_GiveCredits(Store_GetClientAccountID(client), -2250);
	}
	else
	{
		CPrintToChat(client, "%T", "Expend not enough credits", LANG_SERVER);
	}
}

public ExpendByFourCallback(credits, any:client)
{	
	if(credits >= 3000)
	{
		new String:auth[32];
		new String:query[2000];
		new String:gang[62];
		GetClientAuthString(client, auth, sizeof(auth));
		Format(query, sizeof(query), "SELECT Gang FROM Gangs_Users WHERE SteamID = '%s'", auth);
	
		new Handle:hQuery = SQL_Query(hDatabase, query);
		if (hQuery == INVALID_HANDLE)
		{
			return;
		}
		else
		{		
			while (SQL_FetchRow(hQuery))
			{
				SQL_FetchString(hQuery, 0, gang, sizeof(gang));
			}
		}
		CPrintToChat(client, "%T", "Expend by 4", LANG_SERVER);
		ExpendGangSlotsByNum(gang, 4);
		inExpendSlotsProcess[client] = false;
		Store_GiveCredits(Store_GetClientAccountID(client), -3000);
	}
	else
	{
		CPrintToChat(client, "%T", "Expend not enough credits", LANG_SERVER);
	}
}

public ExpendByFiveCallback(credits, any:client)
{	
	if(credits >= 3750)
	{
		new String:auth[32];
		new String:query[2000];
		new String:gang[62];
		GetClientAuthString(client, auth, sizeof(auth));
		Format(query, sizeof(query), "SELECT Gang FROM Gangs_Users WHERE SteamID = '%s'", auth);
	
		new Handle:hQuery = SQL_Query(hDatabase, query);
		if (hQuery == INVALID_HANDLE)
		{
			return;
		}
		else
		{		
			while (SQL_FetchRow(hQuery))
			{
				SQL_FetchString(hQuery, 0, gang, sizeof(gang));
			}
		}
		CPrintToChat(client, "%T", "Expend by 5", LANG_SERVER);
		ExpendGangSlotsByNum(gang, 5);
		inExpendSlotsProcess[client] = false;
		Store_GiveCredits(Store_GetClientAccountID(client), -3750);
	}
	else
	{
		CPrintToChat(client, "%T", "Expend not enough credits", LANG_SERVER);
	}
}

FindRemoveGangMembers(const String:gangname[])
{
	for(new i = 1; i <= MaxClients;i++)
	{
		if(!IsClientConnected(i) || IsFakeClient(i) || !IsClientAuthorized(i))
		continue;
	
		new String:auth[32];
		new String:query[100];
		new String:gang[62];
		GetClientAuthString(i, auth, sizeof(auth));
		Format(query, sizeof(query), "SELECT Gang FROM Gangs_Users WHERE SteamID = '%s'", auth);
	
		new Handle:hQuery = SQL_Query(hDatabase, query);
		if (hQuery == INVALID_HANDLE)
		{
			return;
		}
		else
		{		
			while (SQL_FetchRow(hQuery))
			{
				SQL_FetchString(hQuery, 0, gang, sizeof(gang));
			}
		}
		
		if(!StrEqual(gang, gangname))
		continue;
	
		decl String:gangmember[62];
		decl String:id[62];
		new userid = GetClientUserId(i);
		
		Format(gangmember, sizeof(gangmember), "%N", i);
		Format(id, sizeof(id), "%d", userid);
		AddMenuItem(GRemovePlayer, id, gangmember);	
	}
}

FindAllGangMembers()
{
	for(new i = 1; i <= MaxClients;i++)
	{
		if(!IsClientConnected(i) || IsFakeClient(i) || !IsClientAuthorized(i))
		continue;
	
		new String:auth[32];
		new String:query[100];
		new String:gang[62];
		GetClientAuthString(i, auth, sizeof(auth));
		Format(query, sizeof(query), "SELECT Gang FROM Gangs_Users WHERE SteamID = '%s'", auth);
	
		new Handle:hQuery = SQL_Query(hDatabase, query);
		if (hQuery == INVALID_HANDLE)
		{
			return;
		}
		else
		{		
			while (SQL_FetchRow(hQuery))
			{
				SQL_FetchString(hQuery, 0, gang, sizeof(gang));
			}
		}
		
		if(StrEqual(gang, "none"))
		continue;
	
		decl String:gangmember[62];
		decl String:id[62];
		new userid = GetClientUserId(i);
		
		Format(gangmember, sizeof(gangmember), "%N", i);
		Format(id, sizeof(id), "%d", userid);
		AddMenuItem(GangMasterRemoveMenu, id, gangmember);	
	}
}

FindPremoteDemoteGangMembers(const String:gangname[], client)
{
	for(new i = 1; i <= MaxClients;i++)
	{
		if(!IsClientConnected(i) || IsFakeClient(i) || !IsClientAuthorized(i))
		continue;
	
		new String:auth[32];
		new String:query[100];
		new String:gang[62];
		GetClientAuthString(i, auth, sizeof(auth));
		Format(query, sizeof(query), "SELECT Gang FROM Gangs_Users WHERE SteamID = '%s'", auth);
	
		new Handle:hQuery = SQL_Query(hDatabase, query);
		if (hQuery == INVALID_HANDLE)
		{
			return;
		}
		else
		{		
			while (SQL_FetchRow(hQuery))
			{
				SQL_FetchString(hQuery, 0, gang, sizeof(gang));
			}
		}
		
		if(!StrEqual(gang, gangname))
		continue;
		
		if(i == client)
		continue;
	
		decl String:gangmember[62];
		decl String:id[62];
		new userid = GetClientUserId(i);
		
		Format(gangmember, sizeof(gangmember), "%N", i);
		Format(id, sizeof(id), "%d", userid);
		AddMenuItem(GangPremoteDemoteMenu, id, gangmember);	
	}
}

FindNonAddGangMembers(const String:gangname[])
{
	for(new i = 1; i <= MaxClients;i++)
	{
		if(!IsClientConnected(i) || IsFakeClient(i) || !IsClientAuthorized(i))
		continue;
	
		new String:auth[32];
		new String:query[100];
		new String:gang[62];
		GetClientAuthString(i, auth, sizeof(auth));
		Format(query, sizeof(query), "SELECT Gang FROM Gangs_Users WHERE SteamID = '%s'", auth);
	
		new Handle:hQuery = SQL_Query(hDatabase, query);
		if (hQuery == INVALID_HANDLE)
		{
			return;
		}
		else
		{		
			while (SQL_FetchRow(hQuery))
			{
				SQL_FetchString(hQuery, 0, gang, sizeof(gang));
			}
		}
		
		if(StrEqual(gang, gangname))
		continue;
	
		decl String:gangmember[62];
		decl String:id[62];
		new userid = GetClientUserId(i);
		
		Format(gangmember, sizeof(gangmember), "%N", i);
		Format(id, sizeof(id), "%d", userid);
		AddMenuItem(GAddPlayer, id, gangmember);
	}
}

public DisplayMasterGangRemoveMenu(client)
{
	GangMasterRemoveMenu = CreateMenu(GangMasterRemoveMenuHandler);
	
	new String:GangMasterRemoveTitle[400];
	Format(GangMasterRemoveTitle, sizeof(GangMasterRemoveTitle), "%T", "Gang Master Remove Title", LANG_SERVER);
	SetMenuTitle(GangMasterRemoveMenu, GangMasterRemoveTitle);
	SetMenuExitButton(GangMasterRemoveMenu, true);
	SetMenuExitBackButton(GangMasterRemoveMenu, false);
	
	FindAllGangMembers();
	
	DisplayMenu(GangMasterRemoveMenu, client, MENU_TIME_FOREVER);
}

public DisplayGangListMenuD(client)
{
	GangListMenuDelete = CreateMenu(GangListMenuDeleteHandler);
	
	new String:SelectGangFormat[400];
	Format(SelectGangFormat, sizeof(SelectGangFormat), "%T", "Select Gang", LANG_SERVER);
	SetMenuTitle(GangListMenuDelete, SelectGangFormat);
	SetMenuExitButton(GangListMenuDelete, true);
	SetMenuExitBackButton(GangListMenuDelete, false);
	
	GetServerGangs(GangListMenuDelete);
	
	DisplayMenu(GangListMenuDelete, client, MENU_TIME_FOREVER);
}

public DisplayGangListMenuP(client)
{
	GangListMenuPass = CreateMenu(GangListMenuPassHandler);
	
	new String:SelectGangFormat[400];
	Format(SelectGangFormat, sizeof(SelectGangFormat), "%T", "Select Gang", LANG_SERVER);
	SetMenuTitle(GangListMenuPass, SelectGangFormat);
	SetMenuExitButton(GangListMenuPass, true);
	SetMenuExitBackButton(GangListMenuPass, false);
	
	GetServerGangs(GangListMenuPass);
	
	DisplayMenu(GangListMenuPass, client, MENU_TIME_FOREVER);
}


public DisplayAddMGangMenu(client)
{
	GAddPlayer = CreateMenu(GangAddHandler);
	
	new String:GangAddMenuFormat[400];
	Format(GangAddMenuFormat, sizeof(GangAddMenuFormat), "%T", "Select a Player", LANG_SERVER);
	SetMenuTitle(GAddPlayer, GangAddMenuFormat);
	SetMenuExitButton(GAddPlayer, true);
	SetMenuExitBackButton(GAddPlayer, false);
	
	new String:auth[32];
	new String:query[100];
	new String:gang[62];
	GetClientAuthString(client, auth, sizeof(auth));
	Format(query, sizeof(query), "SELECT Gang FROM Gangs_Users WHERE SteamID = '%s'", auth);
	
	new Handle:hQuery = SQL_Query(hDatabase, query);
	if (hQuery == INVALID_HANDLE)
	{
		return;
	}
	else
	{		
		while (SQL_FetchRow(hQuery))
		{
			SQL_FetchString(hQuery, 0, gang, sizeof(gang));
		}
	}
	
	FindNonAddGangMembers(gang);
	
	Format(PendingGang, sizeof(PendingGang), "%s", gang);
	
	DisplayMenu(GAddPlayer, client, MENU_TIME_FOREVER);
}

public DisplayPremoteDemoteMenu(client)
{
	GangPremoteDemoteMenu = CreateMenu(GangPremoteDemoteMenuHandler);
	SetMenuTitle(GangPremoteDemoteMenu, "Please select a player to Premote/Demote");
	SetMenuExitButton(GangPremoteDemoteMenu, true);
	SetMenuExitBackButton(GangPremoteDemoteMenu, false);
	
	new String:auth[32];
	new String:query[100];
	new String:gang[62];
	GetClientAuthString(client, auth, sizeof(auth));
	Format(query, sizeof(query), "SELECT Gang FROM Gangs_Users WHERE SteamID = '%s'", auth);
	
	new Handle:hQuery = SQL_Query(hDatabase, query);
	if (hQuery == INVALID_HANDLE)
	{
		return;
	}
	else
	{		
		while (SQL_FetchRow(hQuery))
		{
			SQL_FetchString(hQuery, 0, gang, sizeof(gang));
		}
	}
	
	FindPremoteDemoteGangMembers(gang, client);
	DisplayMenu(GangPremoteDemoteMenu, client, MENU_TIME_FOREVER);
}

public GangAddHandler(Handle:menu, MenuAction:action, client, param2)
{
	if (action == MenuAction_End)
	{
		CloseHandle(menu);
	}
	else if (action == MenuAction_Select)
	{
		decl String:info[32];
		new userid;
		new target;
		
		GetMenuItem(menu, param2, info, sizeof(info));
		userid = StringToInt(info);
		
		if ((target = GetClientOfUserId(userid)) == 0)
		{
			CPrintToChat(client, "%T", "Player not available", LANG_SERVER);
		}
		else
		{	
		
			if(target == client)
			{
				CPrintToChat(client, "%T", "Cant invite self", LANG_SERVER);
				return;
			}
		
			new String:auth[32];
			new String:gangtitle[200];
			GetClientAuthString(target, auth, sizeof(auth));

			Format(gangtitle, sizeof(gangtitle), "%T", "Gang Invite Title", LANG_SERVER, client, PendingGang);
			
			SetMenuTitle(GangAcceptMessage, gangtitle);
			DisplayMenu(GangAcceptMessage, target, MENU_TIME_FOREVER);
			GangInviter = client;
			CPrintToChat(client, "%T", "Successfully invited", LANG_SERVER, target);
		}

	}
}

public GangPremoteDemoteMenuHandler(Handle:menu, MenuAction:action, client, param2)
{
	if (action == MenuAction_End)
	{
		CloseHandle(menu);
	}
	else if (action == MenuAction_Select)
	{
		decl String:info[32];
		new userid;
		new target;
		
		GetMenuItem(menu, param2, info, sizeof(info));
		userid = StringToInt(info);
		
		if ((target = GetClientOfUserId(userid)) == 0)
		{
			CPrintToChat(client, "%T", "Player not available", LANG_SERVER);
		}
		else
		{	
			MemberToRank = target;
			CPrintToChat(client, "{green}[Gangs]{default} Successfully selected %N", target);
			
			CPrintToChat(client, "{green}[Gangs]{default} Please write the rank to demote or premote %N", target);
			CPrintToChat(client, "{green}[Gangs]{default} Offical Ranks are: Newbie, Member, Officer, Veteran, Leader. You can also write a custom rank, but it is meaningless for the plugin.");
			inPremoteDemoteProcess[client] = true;
		}
	}
}

public GangBonusesMenuHandler(Handle:menu, MenuAction:action, client, param2)
{
	if(action == MenuAction_Select)
	{
		new String:auth[32];
		new String:query[100];
		new String:gang[62];
		GetClientAuthString(client, auth, sizeof(auth));
		Format(query, sizeof(query), "SELECT Gang FROM Gangs_Users WHERE SteamID = '%s'", auth);
	
		new Handle:hQuery = SQL_Query(hDatabase, query);
		if (hQuery == INVALID_HANDLE)
		{
			return;
		}
		else
		{		
			while (SQL_FetchRow(hQuery))
			{
				SQL_FetchString(hQuery, 0, gang, sizeof(gang));
			}
		}
	
		GangBonusesExplainMenu = CreateMenu(GangBonusesExplainMenuHandler);
	
		if(param2 == 0)
		{
			new ArmorLVL = GetGangBonus(gang, "ArmorLVL");
			
			decl String:ArmorFormat[256];
			
			Format(ArmorFormat, sizeof(ArmorFormat), "%T", "Armor Bonus Level", LANG_SERVER, ArmorLVL);
			
			SetMenuTitle(GangBonusesExplainMenu, "Armor LVL");
			AddMenuItem(GangBonusesExplainMenu, "ArmorLVL", ArmorFormat);
			AddMenuItem(GangBonusesExplainMenu, "upgrade", "Upgrade Bonus");
			DisplayMenu(GangBonusesExplainMenu, client, MENU_TIME_FOREVER);
		}
		
		if(param2 == 1)
		{
			new GunLVL = GetGangBonus(gang, "GunLVL");
			decl String:GunFormat[256];
			
			Format(GunFormat, sizeof(GunFormat), "%T", "Gun Bonus Level", LANG_SERVER, GunLVL);
			
			SetMenuTitle(GangBonusesExplainMenu, "Gun LVL");
			AddMenuItem(GangBonusesExplainMenu, "GunLVL", GunFormat);
			AddMenuItem(GangBonusesExplainMenu, "upgrade", "Upgrade Bonus");
			DisplayMenu(GangBonusesExplainMenu, client, MENU_TIME_FOREVER);
		}
		
		if(param2 == 2)
		{
			new HealthLVL = GetGangBonus(gang, "HealthLVL");
			
			decl String:HealthFormat[256];
			
			Format(HealthFormat, sizeof(HealthFormat), "%T", "Health Bonus Level", LANG_SERVER, HealthLVL);
			
			SetMenuTitle(GangBonusesExplainMenu, "Health LVL");
			AddMenuItem(GangBonusesExplainMenu, "HealthLVL", HealthFormat);
			AddMenuItem(GangBonusesExplainMenu, "upgrade", "Upgrade Bonus");
			DisplayMenu(GangBonusesExplainMenu, client, MENU_TIME_FOREVER);
		}
		
		if(param2 == 3)
		{
			new NadeLVL = GetGangBonus(gang, "NadeLVL");
			
			decl String:NadeFormat[256];
			
			Format(NadeFormat, sizeof(NadeFormat), "%T", "Grenade Bonus Level", LANG_SERVER, NadeLVL);
			
			SetMenuTitle(GangBonusesExplainMenu, "Nade LVL");
			AddMenuItem(GangBonusesExplainMenu, "NadeLVL", NadeFormat);
			AddMenuItem(GangBonusesExplainMenu, "upgrade", "Upgrade Bonus");
			DisplayMenu(GangBonusesExplainMenu, client, MENU_TIME_FOREVER);
		}
		
		if(param2 == 4)
		{
			new DropLVL = GetGangBonus(gang, "DropLVL");
			
			decl String:DropFormat[256];
			
			Format(DropFormat, sizeof(DropFormat), "Current CT Drop Weapon Bonus Level: %i", DropLVL);
			
			SetMenuTitle(GangBonusesExplainMenu, "CT Drop Weapon LVL");
			AddMenuItem(GangBonusesExplainMenu, "DropLVL", DropFormat);
			AddMenuItem(GangBonusesExplainMenu, "upgrade", "Upgrade Bonus");
			DisplayMenu(GangBonusesExplainMenu, client, MENU_TIME_FOREVER);
		}
	}
}

public GangBonusesExplainMenuHandler(Handle:menu, MenuAction:action, client, param2)
{
	if(action == MenuAction_Select)
	{	
		if(param2 == 1)
		{
			new String:auth[32];
			new String:query[100];
			new String:gang[62];
			GetClientAuthString(client, auth, sizeof(auth));
			Format(query, sizeof(query), "SELECT Gang FROM Gangs_Users WHERE SteamID = '%s'", auth);
	
			new Handle:hQuery = SQL_Query(hDatabase, query);
			if (hQuery == INVALID_HANDLE)
			{
				return;
			}
			else
			{		
				while (SQL_FetchRow(hQuery))
				{
					SQL_FetchString(hQuery, 0, gang, sizeof(gang));
				}
			}
		
			decl String:info[32];
			GetMenuItem(menu, 0, info, sizeof(info));
			Format(BonusToUpgrade, sizeof(BonusToUpgrade), "%s", info);
			Store_GetCredits(Store_GetClientAccountID(client), UpgradeBonusCallback, client);
			// bonus
		}
	}
}

public UpgradeBonusCallback(credits, any:client)
{
	new String:auth[32];
	new String:query[100];
	new String:gang[62];
	GetClientAuthString(client, auth, sizeof(auth));
	Format(query, sizeof(query), "SELECT Gang FROM Gangs_Users WHERE SteamID = '%s'", auth);
	
	new Handle:hQuery = SQL_Query(hDatabase, query);
	if (hQuery == INVALID_HANDLE)
	{
		return;
	}
	else
	{		
		while (SQL_FetchRow(hQuery))
		{
			SQL_FetchString(hQuery, 0, gang, sizeof(gang));
		}
	}
	
	new BonusLVL = GetGangBonus(gang, BonusToUpgrade);
	new BonusCost = GetConVarInt(g_hGangUpgradeBonusCredits);
	
	if(credits >= BonusCost)
	{
		if(BonusLVL < 10)
		{
		IncreaseGangBonus(gang, BonusToUpgrade, 1);
		CPrintToChat(client, "%T", "Success UP Bonus", LANG_SERVER, BonusToUpgrade);
		Store_GiveCredits(Store_GetClientAccountID(client), -BonusCost);
		}
		else
		{
		CPrintToChat(client, "%T", "Reached max bonus", LANG_SERVER);
		}
	}
	else
	{
		CPrintToChat(client, "%T", "Bonus not enough credits", LANG_SERVER);
	}
}

public GangBankMenuHandler(Handle:menu, MenuAction:action, client, param2)
{
	if(action == MenuAction_Select)
	{
		if(param2 == 1)
		{
			inGangBankDepositProcess[client] = true;
			CPrintToChat(client, "%T", "Please write deposit", LANG_SERVER);
		}
		
		if(param2 == 2)
		{
			inGangWithdrawProcess[client] = true;
			CPrintToChat(client, "%T", "Please write withdraw", LANG_SERVER);
		}
	}	
}

public GangMasterKeyMenuHandler(Handle:menu, MenuAction:action, client, param2)
{
	if(action == MenuAction_Select)
	{
		if(param2 == 0)
		{
			// davai
		}
		
		if(param2 == 1)
		{
			DisplayGangListMenuD(client);
		}
		
		if(param2 == 2)
		{
			DisplayMasterGangRemoveMenu(client);
		}
		
		if(param2 == 3)
		{
			DisplayGangListMenuP(client);
		}
	}
}

public GangListMenuDeleteHandler(Handle:menu, MenuAction:action, client, param2)
{
	if(action == MenuAction_Select)
	{
		decl String:info[32];
		GetMenuItem(menu, param2, info, sizeof(info));
			
		DisbandGang(info);
			
		CPrintToChat(client, "%T", "Success Gang Delete", LANG_SERVER, info);
		CloseHandle(menu);
	}
}


public GangListMenuPassHandler(Handle:menu, MenuAction:action, client, param2)
{
	if(action == MenuAction_Select)
	{
		GetMenuItem(menu, param2, GangToEdit, sizeof(GangToEdit));
		inEditDisbandPassProcess[client] = true;
		CPrintToChat(client, "{green}[Gangs]{default} Please enter your new password in chat.");
		CloseHandle(menu);
	}
}



public GangRemoveHandler(Handle:menu, MenuAction:action, client, param2)
{
	if (action == MenuAction_End)
	{
		CloseHandle(menu);
	}
	else if (action == MenuAction_Select)
	{
		decl String:info[32];
		new userid;
		new target;
		
		GetMenuItem(menu, param2, info, sizeof(info));
		userid = StringToInt(info);
		
		if ((target = GetClientOfUserId(userid)) == 0)
		{
			CPrintToChat(client, "%T", "Player not available", LANG_SERVER);
		}
		else
		{	
			if(target == client)
			{
				CPrintToChat(client, "%T", "Cant expel self", LANG_SERVER);
				return;
			}
		
			new String:auth[32];
			new String:query[100];
			new String:gang[62];
			GetClientAuthString(client, auth, sizeof(auth));
			Format(query, sizeof(query), "SELECT Gang FROM Gangs_Users WHERE SteamID = '%s'", auth);
	
			new Handle:hQuery = SQL_Query(hDatabase, query);
			if (hQuery == INVALID_HANDLE)
			{
				return;
			}
			else
			{		
				while (SQL_FetchRow(hQuery))
				{
					SQL_FetchString(hQuery, 0, gang, sizeof(gang));
				}
			}
			GetClientAuthString(target, auth, sizeof(auth));
			ExpelGangMember(target, gang);
			CPrintToChat(client, "%T", "Successfully expelled", LANG_SERVER, target);
		}
	}
}

public GangMasterRemoveMenuHandler(Handle:menu, MenuAction:action, client, param2)
{
	if (action == MenuAction_End)
	{
		CloseHandle(menu);
	}
	else if (action == MenuAction_Select)
	{
		decl String:info[32];
		new userid;
		new target;
		
		GetMenuItem(menu, param2, info, sizeof(info));
		userid = StringToInt(info);
		
		if ((target = GetClientOfUserId(userid)) == 0)
		{
			CPrintToChat(client, "%T", "Player not available", LANG_SERVER);
		}
		else
		{	
			if(target == client)
			{
				CPrintToChat(client, "%T", "Cant expel self", LANG_SERVER);
				return;
			}
		
			new String:auth[32];
			new String:query[100];
			new String:gang[62];
			GetClientAuthString(client, auth, sizeof(auth));
			Format(query, sizeof(query), "SELECT Gang FROM Gangs_Users WHERE SteamID = '%s'", auth);
	
			new Handle:hQuery = SQL_Query(hDatabase, query);
			if (hQuery == INVALID_HANDLE)
			{
				return;
			}
			else
			{		
				while (SQL_FetchRow(hQuery))
				{
					SQL_FetchString(hQuery, 0, gang, sizeof(gang));
				}
			}
			GetClientAuthString(target, auth, sizeof(auth));
			ExpelGangMember(target, gang);
			CPrintToChat(client, "%T", "Successfully expelled", LANG_SERVER, target);
		}
	}
}

public GangListerMenuHandler(Handle:menu, MenuAction:action, client, param2)
{
	if (action == MenuAction_End)
	{
		//CloseHandle(menu);
	}
	else if (action == MenuAction_Select)
	{
		decl String:ganginfo[32];
		GetMenuItem(menu, param2, ganginfo, sizeof(ganginfo));
		
		new String:gangname[100];
		new String:leadername[100];
		new String:privacy[100];
		new Members;
		new GangBank;
		
		decl String:query[2000];
		decl String:auth[32];
		new String:result[255];
		GetClientAuthString(client, auth, sizeof(auth));
	
		Format(query, sizeof(query), "SELECT * FROM Gangs_Ganglist WHERE GangName = '%s'", ganginfo);
	
		new Handle:hQuery = SQL_Query(hDatabase, query);
		if (hQuery == INVALID_HANDLE)
		{
			SetFailState("error while query(gang info retrive)");
		}
		else
		{		
			while (SQL_FetchRow(hQuery))
			{
				SQL_FetchString(hQuery, 0, gangname, sizeof(gangname));
				SQL_FetchString(hQuery, 2, leadername, sizeof(leadername));
				Members = SQL_FetchInt(hQuery, 4);
				GangBank = SQL_FetchInt(hQuery, 6);
				SQL_FetchString(hQuery, 7, privacy, sizeof(privacy));
			}
			
			new Handle:GangListerInfoMenu = CreateMenu(GangListerInfoMenuHandler);
			SetMenuTitle(GangListerInfoMenu, "Gang Info");
			
			Format(result, sizeof(result), "Gang Name: %s", gangname);
			AddMenuItem(GangListerInfoMenu, result, result,ITEMDRAW_DISABLED);
			Format(result, sizeof(result), "Leader: %s", leadername);
			AddMenuItem(GangListerInfoMenu, result, result,ITEMDRAW_DISABLED);
			Format(result, sizeof(result), "Current Gang Members: %i", Members);
			AddMenuItem(GangListerInfoMenu, result, result,ITEMDRAW_DISABLED);
			Format(result, sizeof(result), "Current Gang Bank Balance: %i", GangBank);
			AddMenuItem(GangListerInfoMenu, result, result,ITEMDRAW_DISABLED);
			if(StrEqual(privacy, "Public"))
			{
				Format(result, sizeof(result), "Join Gang!");
				AddMenuItem(GangListerInfoMenu, result, result);
			}
			else
			{
				Format(result, sizeof(result), "Join Gang!(PRIVATE)");
				AddMenuItem(GangListerInfoMenu, result, result, ITEMDRAW_DISABLED);
			}
			
			Format(GangListerGangToJoin, sizeof(GangListerGangToJoin), "%s", ganginfo);
			
			SetMenuExitBackButton(GangListerInfoMenu, true);
			DisplayMenu(GangListerInfoMenu, client, MENU_TIME_FOREVER);
			CloseHandle(menu);
		}
	}
}

public GangListerInfoMenuHandler(Handle:menu, MenuAction:action, client, param2)
{
	switch (action) 
	{
		case MenuAction_End: 
		{
			CloseHandle(menu);
		}
		case MenuAction_Select:
		{
			if(param2 == 4)
			{
				new String:gang[62];
				decl String:auth[32];
				decl String:query1[2000];
				GetClientAuthString(client, auth, sizeof(auth));
	
				Format(query1, sizeof(query1), "SELECT Gang FROM Gangs_Users WHERE SteamID = '%s'", auth);
	
				new Handle:hQuery1 = SQL_Query(hDatabase, query1);
				if (hQuery1 == INVALID_HANDLE)
				{
					SetFailState("error while query1(gang retrive)");
				}
				else
				{		
					while (SQL_FetchRow(hQuery1))
					{
						SQL_FetchString(hQuery1, 0, gang, sizeof(gang));
					}
				}
		
				if(StrEqual(gang, GangListerGangToJoin))
				{
					CPrintToChat(client, "%T", "Cant invite self to Gang", LANG_SERVER);
					return;
				}
		
				if(!StrEqual(gang, "none"))
				{
					CPrintToChat(client, "%T", "Must leave first", LANG_SERVER);
					return;
				}
		
				AddGangMember(GangListerGangToJoin, client);
				CPrintToChat(client, "%T", "Success Join", LANG_SERVER , GangListerGangToJoin);
			}
		}
		case MenuAction_Cancel:
		{
			if (param2 == MenuCancel_ExitBack) 
			DisplayGangListerMenu(client);
		}
	}
}

public DisplayGangListerMenu(client)
{
	GangListerMenu = CreateMenu(GangListerMenuHandler);
	
	new String:SelectGangFormat[400];
	Format(SelectGangFormat, sizeof(SelectGangFormat), "%T", "Select Gang", LANG_SERVER);
	SetMenuTitle(GangListerMenu, SelectGangFormat);
	SetMenuExitButton(GangListerMenu, true);
	SetMenuExitBackButton(GangListerMenu, true);
	
	GetServerGangsForLister();
	DisplayMenu(GangListerMenu, client, MENU_TIME_FOREVER);
}

public DisplayRemoveMGangMenu(client)
{
	GRemovePlayer = CreateMenu(GangRemoveHandler);
	SetMenuTitle(GRemovePlayer, "Select a member to remove");
	SetMenuExitButton(GRemovePlayer, true);
	SetMenuExitBackButton(GRemovePlayer, false);
	
	new String:auth[32];
	new String:query[100];
	new String:gang[62];
	GetClientAuthString(client, auth, sizeof(auth));
	Format(query, sizeof(query), "SELECT Gang FROM Gangs_Users WHERE SteamID = '%s'", auth);
	
	new Handle:hQuery = SQL_Query(hDatabase, query);
	if (hQuery == INVALID_HANDLE)
	{
		return;
	}
	else
	{		
		while (SQL_FetchRow(hQuery))
		{
			SQL_FetchString(hQuery, 0, gang, sizeof(gang));
		}
	}
	
	FindRemoveGangMembers(gang);
	DisplayMenu(GRemovePlayer, client, MENU_TIME_FOREVER);
}


public OnClientPutInServer(client)
{
	if(!CheckSQLStatus(client))
	{
		CreateDefaultMember(client);
	}
}

public StartSQL()
{
	SQL_TConnect(StartUP, "gangs");
}

public StartUP(Handle:owner, Handle:hndl, const String:error[], any:data)
{
	if (hndl == INVALID_HANDLE)
	{
		LogError("can not establish connection to database! (%s)", error);
		SetFailState("%s", error);
	} 
	else 
	{
		hDatabase = hndl;
		PrintToServer("[Gangs] Connection to MySQL server succeeded!");
	}
}

public GangMainMenuHandler(Handle:menu, MenuAction:action, param1, param2)
{
	if(action == MenuAction_Select)
	{
		decl String:query[2000];
		decl String:query1[2000];
		decl String:query2[2000];
		new String:gang[62];
		decl String:auth[32];
		new Members;
		new MaxMembers;
		GetClientAuthString(param1, auth, sizeof(auth));
		Format(query, sizeof(query), "SELECT Gang FROM Gangs_Users WHERE SteamID = '%s'", auth);

		new Handle:hQuery = SQL_Query(hDatabase, query);
		if (hQuery == INVALID_HANDLE)
		{
			SetFailState("error while query(0)");
		}
		else
		{		
			while (SQL_FetchRow(hQuery))
			{
				SQL_FetchString(hQuery, 0, gang, sizeof(gang));
			}
		}
		
		Format(query1, sizeof(query1), "SELECT Members FROM Gangs_Ganglist WHERE GangName = '%s'", gang);
		Format(query2, sizeof(query2), "SELECT MaxMembers FROM Gangs_Ganglist WHERE GangName = '%s'", gang);
	
		new Handle:hQuery1 = SQL_Query(hDatabase, query1);
		if (hQuery1 == INVALID_HANDLE)
		{
			SetFailState("error while query(1)");
		}
		else
		{		
			while (SQL_FetchRow(hQuery1))
			{
				Members = SQL_FetchInt(hQuery1, 0);
			}
		}

		new Handle:hQuery2 = SQL_Query(hDatabase, query2);
		if (hQuery2 == INVALID_HANDLE)
		{
			SetFailState("error while query(2)");
		}
		else
		{		
			while (SQL_FetchRow(hQuery2))
			{
			MaxMembers = SQL_FetchInt(hQuery2, 0);
			}
		}
	
		if(param2 == 2)
		{	
			if(Members == MaxMembers)
			{
				CPrintToChat(param1, "%T", "Gang Full", LANG_SERVER);
				return;
			}
			
			DisplayAddMGangMenu(param1);
		}
		
		if(param2 == 3)
		{
			DisplayRemoveMGangMenu(param1);
		}
		
		if(param2 == 4)
		{
			new CreditsToExpend = GetConVarInt(g_hGangExpendSlotsCredits);
			CPrintToChat(param1, "{green}[Gangs]{default} Please write the number of slots you want to add");
			CPrintToChat(param1, "{green}[Gangs]{red} WARNING: Each slot expension costs %i credits!", CreditsToExpend);
			inExpendSlotsProcess[param1] = true;
		}
		
		if(param2 == 5)
		{
			DisplayPremoteDemoteMenu(param1);
		}
		
		if(param2 == 6)
		{
			DisplayMenu(GangBonusesMenu, param1, MENU_TIME_FOREVER);
		}
		
		if(param2 == 7)
		{
			DisplayMenu(GangEditMenu, param1, MENU_TIME_FOREVER);
		}
		
		if(param2 == 8) 
		{
			// gang stats
		}
		
		if(param2 == 9)
		{
			new BankStatus = GetConVarInt(g_hGangBank);
		
			if(BankStatus == 0)
			{
				CPrintToChat(param1, "%T", "Bank Disabled", LANG_SERVER);
				return;
			}
		
			decl String:query3[2000];
			decl String:CurrentCreditsFormat[400];
			new GangCredits;
			Format(query3, sizeof(query3), "SELECT GangBank FROM Gangs_Ganglist WHERE GangName = '%s'", gang);
	
			new Handle:hQuery3 = SQL_Query(hDatabase, query3);
			if (hQuery3 == INVALID_HANDLE)
			{
				SetFailState("error while query3");
			}
			else
			{		
				while (SQL_FetchRow(hQuery3))
				{
					GangCredits = SQL_FetchInt(hQuery3, 0);
				}
			}
		
			GangBankMenu = CreateMenu(GangBankMenuHandler);
			Format(CurrentCreditsFormat, sizeof(CurrentCreditsFormat), "Current Gang Credits: %i", GangCredits);
			SetMenuTitle(GangBankMenu, "Gang Bank");
			AddMenuItem(GangBankMenu, "currentcredits", CurrentCreditsFormat, ITEMDRAW_DISABLED);
			AddMenuItem(GangBankMenu, "1", "Deposit Credits");
			AddMenuItem(GangBankMenu, "2", "Withdraw Credits");
			DisplayMenu(GangBankMenu, param1, MENU_TIME_FOREVER);
		}
		
		if(param2 == 10)
		{
			DisplayMenu(GangLeaveMenu, param1, MENU_TIME_FOREVER);
		}
	}
}

public GangLeaveMenuHandler(Handle:menu, MenuAction:action, client, param2)
{
	if(action == MenuAction_Select)
	{
		if(param2 == 0)
		{
			new String:gang[62];
			decl String:query[2000];
			decl String:auth[32];
			GetClientAuthString(client, auth, sizeof(auth));
	
			Format(query, sizeof(query), "SELECT Gang FROM Gangs_Users WHERE SteamID = '%s'", auth);
	
			new Handle:hQuery = SQL_Query(hDatabase, query);
			if (hQuery == INVALID_HANDLE)
			{
				SetFailState("error while query(gang retrive)");
			}
			else
			{		
				while (SQL_FetchRow(hQuery))
				{
					SQL_FetchString(hQuery, 0, gang, sizeof(gang));
				}
			}
		
			ExpelGangMember(client, gang);
			CPrintToChat(client, "%T", "Gang Leave Success", LANG_SERVER);
		}
		
		if(param2 == 1)
		{
			CPrintToChat(client, "%T", "Gang Stay", LANG_SERVER);
		}
	}
}

public GangEditMenuHandler(Handle:menu, MenuAction:action, client, param2)
{
	if(action == MenuAction_Select)
	{
		if(param2 == 0)
		{
			new ChangeNameCost = GetConVarInt(g_hGangChangeNameCredits);
			
			inGangChangeNameProcess[client] = true;
			CPrintToChat(client, "{green}[Gangs]{default} Please type the Gang name you wish to change to.");
			CPrintToChat(client, "{green}[Gangs]{red} WARNING: Changing a Gang name costs %i credits!", ChangeNameCost);
		}
		
		if(param2 == 1)
		{
			DisplayMenu(GangPrivacyMenu, client, MENU_TIME_FOREVER);
		}
		
		if(param2 == 2)
		{
			CPrintToChat(client, "%T", "Please type disband pass", LANG_SERVER);
			inGangDisbandProcess[client] = true;
		}
	}
}

public GangPrivacyMenuHandler(Handle:menu, MenuAction:action, client, param2)
{
	if(action == MenuAction_Select)
	{
		new String:gang[62];
		decl String:query[2000];
		decl String:auth[32];
		GetClientAuthString(client, auth, sizeof(auth));
	
		Format(query, sizeof(query), "SELECT Gang FROM Gangs_Users WHERE SteamID = '%s'", auth);
	
		new Handle:hQuery = SQL_Query(hDatabase, query);
		if (hQuery == INVALID_HANDLE)
		{
			SetFailState("error while query(gang retrive)");
		}
		else
		{		
			while (SQL_FetchRow(hQuery))
			{
				SQL_FetchString(hQuery, 0, gang, sizeof(gang));
			}
		}
	
		if(param2 == 0)
		{
			SetGangPrivacy(gang, "Public");
			CPrintToChat(client, "%T", "Privacy Public", LANG_SERVER);
		}
		
		if(param2 == 1)
		{
			SetGangPrivacy(gang, "Private");
			CPrintToChat(client, "%T", "Privacy Private", LANG_SERVER);
		}
	}
}

public GangAcceptMessageHandler(Handle:menu, MenuAction:action, client, param2)
{
	if(action == MenuAction_Select)
	{
		if(param2 == 0)
		{
			new String:gang[62];
			decl String:query[2000];
			decl String:auth[32];
			GetClientAuthString(client, auth, sizeof(auth));
	
			Format(query, sizeof(query), "SELECT Gang FROM Gangs_Users WHERE SteamID = '%s'", auth);
	
			new Handle:hQuery = SQL_Query(hDatabase, query);
			if (hQuery == INVALID_HANDLE)
			{
				SetFailState("error while query(gang retrive)");
			}
			else
			{		
				while (SQL_FetchRow(hQuery))
				{
					SQL_FetchString(hQuery, 0, gang, sizeof(gang));
				}
			}
			
			if(!StrEqual(gang, "none"))
			{
				CPrintToChat(client, "%T", "Must leave first", LANG_SERVER);
				return;
			}
		
			AddGangMember(PendingGang, client);
			CPrintToChat(client, "%T", "Success Join", LANG_SERVER, PendingGang);
			CPrintToChat(GangInviter, "%T", "Player Joined Gang",client);
		}
		
		if(param2 == 1)
		{
			CPrintToChat(client, "%T", "Success Decline", LANG_SERVER, PendingGang);
			CPrintToChat(GangInviter, "%T", "Player declined Gang",client);
		}
	}
}


public CreateGangCreditCallback(credits, any:client)
{	
	new GangCreateCredits = GetConVarInt(g_hGangCreateCredits);
	
	if(credits >= GangCreateCredits)
	{
		CreateGang(TempArgument, client);
		AddGangMember(TempArgument, client);
		CreateDefaultBonuses(TempArgument);
		SetGangMemberRank(client, "Leader");
		inCreateDisbandPassProcess[client] = true;
		Store_GiveCredits(Store_GetClientAccountID(client), -GangCreateCredits);
		CPrintToChat(client, "{green}[Gangs]{default} Successfuly created gang: '%s'", TempArgument);
		CPrintToChat(client, "{green}[Gangs]{default} The default password for disbanding gangs is NOPASS");
		CPrintToChat(client, "{green}[Gangs]{default} You can type right now in chat what pass would you like to use. Passwords can include any number and letter.");
	}
	else
	{
		CPrintToChat(client, "{green}[Gangs]{default} You don't have enough credits to create yourself a Gang!");
	}
}

CreateGang(const String:gangname[], client)
{
	decl String:auth[32];
	GetClientAuthString(client, auth, sizeof(auth));
	decl String:query1[2048];
	Format(query1, sizeof(query1), "INSERT INTO Gangs_Ganglist (GangName,LeaderID,LeaderName,Members,MaxMembers,GangPass,GangBank,GangPrivacy) VALUES ('%s','%s','%N', 0, 3, 'NOPASS', 0, 'Private')", gangname, auth, client);
	if (!SQL_FastQuery(hDatabase, query1))
	{
		new String:error[255];
		SQL_GetError(hDatabase, error, sizeof(error));
		PrintToServer("Failed to query (error: %s)", error);
	}
}

DisbandGang(const String:gangname[])
{
		decl String:query[2048];
		Format(query, sizeof(query), "DELETE FROM Gangs_Ganglist WHERE GangName = '%s'", gangname);
		if (!SQL_FastQuery(hDatabase, query))
		{
			new String:error[255];
			SQL_GetError(hDatabase, error, sizeof(error));
			PrintToServer("Failed to query (error: %s)", error);
		}
		
		new String:query1[2000];
		Format(query1, sizeof(query1), "UPDATE Gangs_Users SET Gang = 'none', Rank = 'none' WHERE Gang = '%s'", gangname);
		if (!SQL_FastQuery(hDatabase, query1))
		{
			new String:error[255];
			SQL_GetError(hDatabase, error, sizeof(error));
			PrintToServer("Failed to query1 (error: %s)", error);
		}
		
		decl String:query2[2048];
		Format(query2, sizeof(query2), "DELETE FROM Gangs_GangBonuses WHERE GangName = '%s'", gangname);
		if (!SQL_FastQuery(hDatabase, query2))
		{
			new String:error[255];
			SQL_GetError(hDatabase, error, sizeof(error));
			PrintToServer("Failed to query (error: %s)", error);
		}
}

CreateDefaultMember(client)
{
	if(IsFakeClient(client))
	return;

	decl String:query[2048];
	decl String:auth[32];
	GetClientAuthString(client, auth, sizeof(auth));
	Format(query, sizeof(query), "INSERT INTO Gangs_Users (SteamID,Name,Gang,Rank) VALUES ('%s','%N', 'none', 'none')", auth, client);
	if (!SQL_FastQuery(hDatabase, query))
	{
		new String:error[255];
		SQL_GetError(hDatabase, error, sizeof(error));
		PrintToServer("Failed to query (error: %s)", error);
	}
}

CreateGangPassword(const String:password[], const String:gangname[])
{
	decl String:query[2000];
	Format(query, sizeof(query), "UPDATE Gangs_Ganglist SET GangPass = '%s' WHERE GangName = '%s'", password, gangname);
	if (!SQL_FastQuery(hDatabase, query))
	{
		new String:error[255];
		SQL_GetError(hDatabase, error, sizeof(error));
		PrintToServer("Failed to query (error: %s)", error);
	}	
}

CreateDefaultBonuses(const String:gangname[])
{
	decl String:query[2000];
	Format(query, sizeof(query), "INSERT INTO Gangs_GangBonuses (GangName,ArmorLVL,GunLVL,HealthLVL,NadeLVL,DropLVL) VALUES ('%s',0,0,0,0,0)", gangname);
	if (!SQL_FastQuery(hDatabase, query))
	{
		new String:error[255];
		SQL_GetError(hDatabase, error, sizeof(error));
		PrintToServer("Failed to query (error: %s)", error);
	}	
}

IncreaseGangBonus(const String:gangname[], const String:bonus[], increase)
{
	decl String:query[2000];
	Format(query, sizeof(query), "UPDATE Gangs_GangBonuses SET %s = %s + %i WHERE GangName = '%s'", bonus, bonus, increase, gangname);
	if (!SQL_FastQuery(hDatabase, query))
	{
		new String:error[255];
		SQL_GetError(hDatabase, error, sizeof(error));
		PrintToServer("Failed to query (error: %s)", error);
	}	
}

GetGangBonus(const String:gangname[], const String:bonus[])
{
	new lvl;
	new String:query[2000];
	Format(query, sizeof(query), "SELECT %s FROM Gangs_GangBonuses WHERE GangName = '%s'", bonus, gangname);
	
	new Handle:hQuery = SQL_Query(hDatabase, query);
	if (hQuery == INVALID_HANDLE)
	{
		return false;
	}
	else
	{		
		while (SQL_FetchRow(hQuery))
		{
			lvl = SQL_FetchInt(hQuery, 0);
		}
	}
	
	return lvl;
}

UpdateGangName(const String:lastname[], const String:newname[])
{
	decl String:query[2000];
	Format(query, sizeof(query), "UPDATE Gangs_Ganglist SET GangName = '%s' WHERE GangName = '%s'", newname, lastname);
	if (!SQL_FastQuery(hDatabase, query))
	{
		new String:error[255];
		SQL_GetError(hDatabase, error, sizeof(error));
		PrintToServer("Failed to query (error: %s)", error);
	}
	
	new String:query1[2000];
	Format(query1, sizeof(query1), "UPDATE Gangs_Users SET Gang = '%s' WHERE Gang = '%s'", newname, lastname);
	if (!SQL_FastQuery(hDatabase, query1))
	{
		new String:error[255];
		SQL_GetError(hDatabase, error, sizeof(error));
		PrintToServer("Failed to query1 (error: %s)", error);
	}
	
	new String:query2[2000];
	Format(query2, sizeof(query2), "UPDATE Gangs_GangBonuses SET GangName = '%s' WHERE GangName = '%s'", newname, lastname);
	if (!SQL_FastQuery(hDatabase, query2))
	{
		new String:error[255];
		SQL_GetError(hDatabase, error, sizeof(error));
		PrintToServer("Failed to query2 (error: %s)", error);
	}
}

GetServerGangs(Handle:menuhandle)
{
	new String:query[100];
	new String:gangname[62];
	Format(query, sizeof(query), "SELECT GangName FROM Gangs_Ganglist");
	
	new Handle:hQuery = SQL_Query(hDatabase, query);
	if (hQuery == INVALID_HANDLE)
	return;
		
		
	if (!SQL_GetRowCount(hQuery)) 
	{
		AddMenuItem(menuhandle, "none", "Cannot find any Gangs on DataBase");
	}
	else
	{		
		while (SQL_FetchRow(hQuery))
		{
			SQL_FetchString(hQuery, 0, gangname, sizeof(gangname));
			AddMenuItem(menuhandle, gangname, gangname);				
		}
	}
}

GetServerGangsForLister()
{
	new String:query[2000];
	new String:gangname[100];
	new String:privacy[100];
	Format(query, sizeof(query), "SELECT * FROM Gangs_Ganglist");
	
	new Handle:hQuery = SQL_Query(hDatabase, query);
	if (hQuery == INVALID_HANDLE)
	return;
		
	if (!SQL_GetRowCount(hQuery)) 
	{
		AddMenuItem(GangListerMenu, "none", "Cannot find any Gangs on DataBase");
	}
	else
	{		
		while (SQL_FetchRow(hQuery))
		{
			SQL_FetchString(hQuery, 0, gangname, sizeof(gangname));
			SQL_FetchString(hQuery, 7, privacy, sizeof(privacy));	
			AddMenuItem(GangListerMenu, gangname, gangname);

		}
	}
}

/*
			if(StrEqual(privacy, "Private"))
			{
				new String:gangprivate[100];
				Format(gangprivate, sizeof(gangprivate), "%s(PRIVATE)", gangname);
				AddMenuItem(GangListerMenu, gangprivate, gangprivate, ITEMDRAW_DISABLED);
			}
			else
			{
				AddMenuItem(GangListerMenu, gangname, gangname);
			}			
*/

CheckSQLStatus(client)
{
	new String:auth[32];
	new String:query[2000];
	GetClientAuthString(client, auth, sizeof(auth));
	Format(query, sizeof(query), "SELECT Gang FROM Gangs_Users WHERE SteamID = '%s'", auth);
	
	new Handle:hQuery = SQL_Query(hDatabase, query);
	if (hQuery == INVALID_HANDLE)
	{
		return false;
	}
	else
	{		
		if (!SQL_GetRowCount(hQuery)) 
		{
			return false;
		}
		else
		{
			return true;
		}	
	}
}

AddGangMember(const String:gangname[], client)
{
	decl String:query[2048];
	decl String:query1[2048];
	decl String:auth[32];
	GetClientAuthString(client, auth, sizeof(auth));
	Format(query, sizeof(query), "UPDATE Gangs_Ganglist SET Members = Members + 1 WHERE GangName = '%s'", gangname);
	
	if (!SQL_FastQuery(hDatabase, query))
	{
	new String:error[255];
	SQL_GetError(hDatabase, error, sizeof(error));
	PrintToServer("Failed to query (error: %s)", error);
	}
	
	Format(query1, sizeof(query1), "UPDATE Gangs_Users SET Gang = '%s', Rank = 'Newbie' WHERE SteamID = '%s'", gangname, auth);
	if (!SQL_FastQuery(hDatabase, query1))
	{
		new String:error[255];
		SQL_GetError(hDatabase, error, sizeof(error));
		PrintToServer("Failed to query (error: %s)", error);
	}
}

ExpelGangMember(client, const String:gangname[])
{
		decl String:auth[32];
		GetClientAuthString(client, auth, sizeof(auth));
		decl String:query[2000];
		Format(query, sizeof(query), "UPDATE Gangs_Users SET Gang = 'none', Rank = 'none' WHERE SteamID = '%s'", auth);
		if (!SQL_FastQuery(hDatabase, query))
		{
			new String:error[255];
			SQL_GetError(hDatabase, error, sizeof(error));
			PrintToServer("Failed to query (error: %s)", error);
		}
		
		Format(query, sizeof(query), "UPDATE Gangs_Ganglist SET Members = Members - 1 WHERE GangName = '%s'", gangname);
	
		if (!SQL_FastQuery(hDatabase, query))
		{
		new String:error[255];
		SQL_GetError(hDatabase, error, sizeof(error));
		PrintToServer("Failed to query (error: %s)", error);
		}
}

SetGangMemberRank(client, const String:rank[])
{
		decl String:auth[32];
		GetClientAuthString(client, auth, sizeof(auth));
		decl String:query[234];
		Format(query, sizeof(query), "UPDATE Gangs_Users SET Rank = '%s' WHERE SteamID = '%s'", rank, auth);
		if (!SQL_FastQuery(hDatabase, query))
		{
			new String:error[255];
			SQL_GetError(hDatabase, error, sizeof(error));
			PrintToServer("Failed to query (error: %s)", error);
		}
}

ExpendGangSlotsByNum(const String:gangname[], slots)
{
		decl String:query[2000];
		Format(query, sizeof(query), "UPDATE Gangs_Ganglist SET MaxMembers = MaxMembers + %i WHERE GangName = '%s'", slots, gangname);
	
		if (!SQL_FastQuery(hDatabase, query))
		{
		new String:error[255];
		SQL_GetError(hDatabase, error, sizeof(error));
		PrintToServer("Failed to query (error: %s)", error);
		}
}

SetGangPrivacy(const String:gangname[], const String:privcay[])
{
		decl String:query[2000];
		Format(query, sizeof(query), "UPDATE Gangs_Ganglist SET GangPrivacy = '%s' WHERE GangName = '%s'", privcay, gangname);
	
		if (!SQL_FastQuery(hDatabase, query))
		{
		new String:error[255];
		SQL_GetError(hDatabase, error, sizeof(error));
		PrintToServer("Failed to query (error: %s)", error);
		}
}

AddBankCredits(const String:gangname[], credits)
{
	decl String:query[2000];
	Format(query, sizeof(query), "UPDATE Gangs_Ganglist SET GangBank = GangBank + %i WHERE GangName = '%s'", credits, gangname);
	if (!SQL_FastQuery(hDatabase, query))
	{
		new String:error[255];
		SQL_GetError(hDatabase, error, sizeof(error));
		PrintToServer("Failed to query (error: %s)", error);
	}
}

RemoveBankCredits(const String:gangname[], credits)
{
	decl String:query[2000];
	Format(query, sizeof(query), "UPDATE Gangs_Ganglist SET GangBank = GangBank - %i WHERE GangName = '%s'", credits, gangname);
	if (!SQL_FastQuery(hDatabase, query))
	{
		new String:error[255];
		SQL_GetError(hDatabase, error, sizeof(error));
		PrintToServer("Failed to query (error: %s)", error);
	}
}

SetClientArmor(client, armor)
{
	SetEntProp(client, Prop_Send, "m_ArmorValue", armor);
}

CheckArmorBonus(const String:gangname[], client)
{
	new ArmorLVL = GetGangBonus(gangname, "ArmorLVL");

	if(ArmorLVL > 0)
	{
		new RandomArmor = GetRandomInt(1, 100);
		
		switch(ArmorLVL)
		{
			case 1:
			{
				if(RandomArmor < 5)
				{
					SetClientArmor(client, RandomArmor);
					CPrintToChat(client, "%T", "Successfully Applied Armor", LANG_SERVER);
				}
			}
			case 2:
			{
				if(RandomArmor < 10)
				{
					SetClientArmor(client, RandomArmor);
					CPrintToChat(client, "%T", "Successfully Applied Armor", LANG_SERVER);
				}
			}
			case 3:
			{
				if(RandomArmor < 15)
				{
					SetClientArmor(client, RandomArmor);
					CPrintToChat(client, "%T", "Successfully Applied Armor", LANG_SERVER);
				}
			}
			case 4:
			{
				if(RandomArmor < 20)
				{
					SetClientArmor(client, RandomArmor);
					CPrintToChat(client, "%T", "Successfully Applied Armor", LANG_SERVER);
				}	
			}
			case 5:
			{
				if(RandomArmor < 25)
				{
					SetClientArmor(client, RandomArmor);
					CPrintToChat(client, "%T", "Successfully Applied Armor", LANG_SERVER);
				}	
			}
			case 6:
			{
				if(RandomArmor < 30)
				{
					SetClientArmor(client, RandomArmor);
					CPrintToChat(client, "%T", "Successfully Applied Armor", LANG_SERVER);
				}		
			}
			case 7:
			{
				if(RandomArmor < 35)
				{
					SetClientArmor(client, RandomArmor);
					CPrintToChat(client, "%T", "Successfully Applied Armor", LANG_SERVER);
				}		
			}
			case 8:
			{
				if(RandomArmor < 40)
				{
					SetClientArmor(client, RandomArmor);
					CPrintToChat(client, "%T", "Successfully Applied Armor", LANG_SERVER);
				}		
			}
			case 9:
			{
				if(RandomArmor < 45)
				{
					SetClientArmor(client, RandomArmor);
					CPrintToChat(client, "%T", "Successfully Applied Armor", LANG_SERVER);
				}		
			}
			case 10:
			{
				if(RandomArmor < 50)
				{
					SetClientArmor(client, RandomArmor);
					CPrintToChat(client, "%T", "Successfully Applied Armor", LANG_SERVER);
				}	
			}
		}
	}
}

CheckGunBonus(const String:gangname[], client)
{
	new GunLVL = GetGangBonus(gangname, "GunLVL");

	if(GunLVL > 0)
	{
		new RandomGun = GetRandomInt(1, 100);
		
		switch(GunLVL)
		{
			case 1:
			{
				if(RandomGun < 5)
				{
					GivePlayerItem(client, "weapon_glock");
					CPrintToChat(client, "%T", "Successfully Applied Gun", LANG_SERVER);
				}
			}
			case 2:
			{
				if(RandomGun < 10)
				{
					GivePlayerItem(client, "weapon_glock");
					CPrintToChat(client, "%T", "Successfully Applied Gun", LANG_SERVER);
				}
			}
			case 3:
			{
				if(RandomGun < 15)
				{
					GivePlayerItem(client, "weapon_glock");
					CPrintToChat(client, "%T", "Successfully Applied Gun", LANG_SERVER);
				}
			}
			case 4:
			{
				if(RandomGun < 20)
				{
					GivePlayerItem(client, "weapon_glock");
					CPrintToChat(client, "%T", "Successfully Applied Gun", LANG_SERVER);
				}	
			}
			case 5:
			{
				if(RandomGun < 25)
				{
					GivePlayerItem(client, "weapon_glock");
					CPrintToChat(client, "%T", "Successfully Applied Gun", LANG_SERVER);
				}	
			}
			case 6:
			{
				if(RandomGun < 30)
				{
					GivePlayerItem(client, "weapon_glock");
					CPrintToChat(client, "%T", "Successfully Applied Gun", LANG_SERVER);
				}	
			}
			case 7:
			{
				if(RandomGun < 35)
				{
					GivePlayerItem(client, "weapon_glock");
					CPrintToChat(client, "%T", "Successfully Applied Gun", LANG_SERVER);
				}
			}
			case 8:
			{
				if(RandomGun < 40)
				{
					GivePlayerItem(client, "weapon_glock");
					CPrintToChat(client, "%T", "Successfully Applied Gun", LANG_SERVER);
				}	
			}
			case 9:
			{
				if(RandomGun < 45)
				{
					GivePlayerItem(client, "weapon_glock");
					CPrintToChat(client, "%T", "Successfully Applied Gun", LANG_SERVER);
				}	
			}
			case 10:
			{
				if(RandomGun < 50)
				{
					GivePlayerItem(client, "weapon_glock");
					CPrintToChat(client, "%T", "Successfully Applied Gun", LANG_SERVER);
				}		
			}
		}
	}
}

CheckHealthBonus(const String:gangname[], client)
{
	new HealthLVL = GetGangBonus(gangname, "HealthLVL");
	
	if(HealthLVL > 0)
	{
		new RandomHealth = GetRandomInt(1, 100);
		new hp = GetClientHealth(client);
		
		switch(HealthLVL)
		{
			case 1:
			{
				if(RandomHealth < 5)
				{
					SetEntityHealth(client, hp + RandomHealth);
					CPrintToChat(client, "%T", "Successfully Applied HP", LANG_SERVER);
				}
			}
			case 2:
			{
				if(RandomHealth < 10)
				{
					SetEntityHealth(client, hp + RandomHealth);
					CPrintToChat(client, "%T", "Successfully Applied HP", LANG_SERVER);
				}
			}
			case 3:
			{
				if(RandomHealth < 15)
				{
					SetEntityHealth(client, hp + RandomHealth);
					CPrintToChat(client, "%T", "Successfully Applied HP", LANG_SERVER);
				}
			}
			case 4:
			{
				if(RandomHealth < 20)
				{
					SetEntityHealth(client, hp + RandomHealth);
					CPrintToChat(client, "%T", "Successfully Applied HP", LANG_SERVER);
				}	
			}
			case 5:
			{
				if(RandomHealth < 25)
				{
					SetEntityHealth(client, hp + RandomHealth);
					CPrintToChat(client, "%T", "Successfully Applied HP", LANG_SERVER);
				}	
			}
			case 6:
			{
				if(RandomHealth < 30)
				{
					SetEntityHealth(client, hp + RandomHealth);
					CPrintToChat(client, "%T", "Successfully Applied HP", LANG_SERVER);
				}	
			}
			case 7:
			{
				if(RandomHealth < 35)
				{
					SetEntityHealth(client, hp + RandomHealth);
					CPrintToChat(client, "%T", "Successfully Applied HP", LANG_SERVER);
				}
			}
			case 8:
			{
				if(RandomHealth < 40)
				{
					SetEntityHealth(client, hp + RandomHealth);
					CPrintToChat(client, "%T", "Successfully Applied HP", LANG_SERVER);
				}	
			}
			case 9:
			{
				if(RandomHealth < 45)
				{
					SetEntityHealth(client, hp + RandomHealth);
					CPrintToChat(client, "%T", "Successfully Applied HP", LANG_SERVER);
				}	
			}
			case 10:	
			{
				if(RandomHealth < 50)
				{
					SetEntityHealth(client, hp + RandomHealth);
					CPrintToChat(client, "%T", "Successfully Applied HP", LANG_SERVER);
				}	
			}
		}
	}
}

CheckGrenadeBonus(const String:gangname[], client)
{
	new NadeLVL = GetGangBonus(gangname, "NadeLVL");

	if(NadeLVL > 0)
	{
		new RandomNade = GetRandomInt(1, 100);
		
		switch(NadeLVL)
		{
			case 1:
			{
				if(RandomNade < 5)
				{
					GivePlayerItem(client, "weapon_flashbang");
					GivePlayerItem(client, "weapon_hegrenade");
					CPrintToChat(client, "%T", "Successfully Applied Nade", LANG_SERVER);
				}
			}
			case 2:
			{
				if(RandomNade < 10)
				{
					GivePlayerItem(client, "weapon_flashbang");
					GivePlayerItem(client, "weapon_hegrenade");
					CPrintToChat(client, "%T", "Successfully Applied Nade", LANG_SERVER);
				}
			}
			case 3:
			{
				if(RandomNade < 15)
				{
					GivePlayerItem(client, "weapon_flashbang");
					GivePlayerItem(client, "weapon_hegrenade");
					CPrintToChat(client, "%T", "Successfully Applied Nade", LANG_SERVER);
				}
			}
			case 4:
			{
				if(RandomNade < 20)
				{
					GivePlayerItem(client, "weapon_flashbang");
					GivePlayerItem(client, "weapon_hegrenade");
					CPrintToChat(client, "%T", "Successfully Applied Nade", LANG_SERVER);
				}	
			}
			case 5:
			{
				if(RandomNade < 25)
				{
					GivePlayerItem(client, "weapon_flashbang");
					GivePlayerItem(client, "weapon_hegrenade");
					CPrintToChat(client, "%T", "Successfully Applied Nade", LANG_SERVER);
				}	
			}
			case 6:
			{
				if(RandomNade < 30)
				{
					GivePlayerItem(client, "weapon_flashbang");
					GivePlayerItem(client, "weapon_hegrenade");
					CPrintToChat(client, "%T", "Successfully Applied Nade", LANG_SERVER);
				}
			}
			case 7:
			{
				if(RandomNade < 35)
				{
					GivePlayerItem(client, "weapon_flashbang");
					GivePlayerItem(client, "weapon_hegrenade");
					CPrintToChat(client, "%T", "Successfully Applied Nade", LANG_SERVER);
				}	
			}
			case 8:
			{
				if(RandomNade < 40)
				{
					GivePlayerItem(client, "weapon_flashbang");
					GivePlayerItem(client, "weapon_hegrenade");
					CPrintToChat(client, "%T", "Successfully Applied Nade", LANG_SERVER);
				}	
			}
			case 9:
			{
				if(RandomNade < 45)
				{
					GivePlayerItem(client, "weapon_flashbang");
					GivePlayerItem(client, "weapon_hegrenade");
					CPrintToChat(client, "%T", "Successfully Applied Nade", LANG_SERVER);
				}
			}
			case 10:
			{
				if(RandomNade < 50)
				{
					GivePlayerItem(client, "weapon_flashbang");
					GivePlayerItem(client, "weapon_hegrenade");
					CPrintToChat(client, "%T", "Successfully Applied Nade", LANG_SERVER);
				}	
			}
		}
	}
}